Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography 1.22
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.bouncycastle.jce.provider
Class JCESecretKeyFactory

    java.lang.Object
      |
      +--javax.crypto.SecretKeyFactorySpi
            |
            +--org.bouncycastle.jce.provider.JCESecretKeyFactory

Direct Known Subclasses:
  JCESecretKeyFactory.DES, JCESecretKeyFactory.DESede, JCESecretKeyFactory.PBE_PKCS12, JCESecretKeyFactory.PBE_PKCS5

public class JCESecretKeyFactory
extends SecretKeyFactorySpi

Nested Class Summary
`static class` | `JCESecretKeyFactory.DES`
`static class` | `JCESecretKeyFactory.DESede`
`static class` | `JCESecretKeyFactory.PBE_PKCS12` PBE password processing for PKCS12 - unicode, big endian order, with two zero pad bytes.
`static class` | `JCESecretKeyFactory.PBE_PKCS5` PBE password processing for PKCS5 - ascii - single byte per character, no padding.

Field Summary
`protected java.lang.String` | `algName`

Constructor Summary
`protected` | `JCESecretKeyFactory(java.lang.String algName)`

Method Summary
`protected SecretKey` | `engineGenerateSecret(KeySpec keySpec)` Generates a `SecretKey` object from the provided key specification (key material).
`protected KeySpec` | `engineGetKeySpec(SecretKey key, java.lang.Class keySpec)` Returns a specification (key material) of the given key object in the requested format.
`protected SecretKey` | `engineTranslateKey(SecretKey key)` Translates a key object, whose provider may be unknown or potentially untrusted, into a corresponding key object of this secret-key factory.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### algName

    protected java.lang.String algName

Constructor Detail

### JCESecretKeyFactory

    protected JCESecretKeyFactory(java.lang.String algName)

Method Detail

### engineGenerateSecret

    protected SecretKey engineGenerateSecret(KeySpec keySpec)
                                      throws InvalidKeySpecException

  Description copied from class: `SecretKeyFactorySpi`
  Generates a `SecretKey` object from the provided key specification (key material).

  Specified by:
    `engineGenerateSecret` in class `SecretKeyFactorySpi`
  Parameters:
    `keySpec` - the specification (key material) of the secret key
  Returns:
    the secret key
  Throws:
    `InvalidKeySpecException` - if the given key specification is inappropriate for this secret-key factory to produce a secret key.

### engineGetKeySpec

    protected KeySpec engineGetKeySpec(SecretKey key,
                                       java.lang.Class keySpec)
                                throws InvalidKeySpecException

  Description copied from class: `SecretKeyFactorySpi`
  Returns a specification (key material) of the given key object in the requested format.

  Specified by:
    `engineGetKeySpec` in class `SecretKeyFactorySpi`
  Parameters:
    `key` - the key
    `keySpec` - the requested format in which the key material shall be returned
  Returns:
    the underlying key specification (key material) in the requested format
  Throws:
    `InvalidKeySpecException` - if the requested key specification is inappropriate for the given key (e.g., the algorithms associated with `key` and `keySpec` do not match, or `key` references a key on a cryptographic hardware device whereas `keySpec` is the specification of a software-based key), or the given key cannot be dealt with (e.g., the given key has an algorithm or format not supported by this secret-key factory).

### engineTranslateKey

    protected SecretKey engineTranslateKey(SecretKey key)
                                    throws java.security.InvalidKeyException

  Description copied from class: `SecretKeyFactorySpi`
  Translates a key object, whose provider may be unknown or potentially untrusted, into a corresponding key object of this secret-key factory.

  Specified by:
    `engineTranslateKey` in class `SecretKeyFactorySpi`
  Parameters:
    `key` - the key whose provider is unknown or untrusted
  Returns:
    InvalidKeyException if the given key cannot be processed by this secret-key factory.
    `java.security.InvalidKeyException`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography 1.22
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD